Attribute VB_Name = "RASAPI"
'----------------------------------------------------
' Autore: Moreno Sirri,  1998 - 1999
' Per informazioni: sirri@morenosoft.com
' Tutto il codice contenuto nel progetto  Freeware,
' a patto che si riportino i dati dell'autore
'----------------------------------------------------

'-------------------------------------------------
' Funzioni, Strutture e costanti generali
'-------------------------------------------------

Public Const RAS_MaxEntryName As Integer = 256 + 1
'Questi sono i valori dichiarati da Microsoft:
'Public Const RAS_MaxDeviceType = 16
'Public Const RAS_MaxDeviceName = 128
'Public Const RAS_MaxPhoneNumber = 128
Public Const RAS_MaxDeviceType As Integer = 16
Public Const RAS_MaxDeviceName As Integer = 128 + 1
Public Const RAS_MaxPhoneNumber = 128 + 1
Public Const RAS_MaxCallbackNumber = RAS_MaxPhoneNumber

Public Const RAS_RASCONNSIZE As Integer = 412
Public Const ERROR_SUCCESS = 0&

Public Type RASCONN
    dwSize As Long
    hRasConn As Long
    szEntryName(RAS_MaxEntryName) As Byte
    szDeviceType(RAS_MaxDeviceType) As Byte
    szDeviceName(RAS_MaxDeviceName) As Byte
End Type

Public Type RASENTRYNAME
    dwSize As Long
    szEntryName(RAS_MaxEntryName) As Byte
End Type

Public Declare Function RasEnumConnections Lib "RasApi32.DLL" Alias "RasEnumConnectionsA" (lprasconn As Any, lpcb As Long, lpcConnections As Long) As Long
Public Declare Function RasEnumEntries Lib "RasApi32.DLL" Alias "RasEnumEntriesA" (ByVal reserved As String, ByVal lpszPhonebook As String, lprasentryname As Any, lpcb As Long, lpcEntries As Long) As Long
Public Declare Function RasHangUp Lib "RasApi32.DLL" Alias "RasHangUpA" (ByVal hRasConn As Long) As Long
Public Declare Function RasCreatePhonebookEntry Lib "RasApi32.DLL" Alias "RasCreatePhonebookEntryA" (ByVal hWND As Long, ByVal lpszPhonebook As String) As Long
Public Declare Function RasEditPhonebookEntry Lib "RasApi32.DLL" Alias "RasEditPhonebookEntryA" (ByVal hWND As Long, ByVal lpszPhonebook As String, ByVal lpszEntryName As String) As Long
Public Declare Function RasDeleteEntry Lib "RasApi32.DLL" Alias "RasDeleteEntryA" (ByVal pszPhonebook As String, ByVal lpszEntry As String) As Long
Public Declare Function RasRenameEntry Lib "RasApi32.DLL" Alias "RasRenameEntryA" (ByVal pszPhonebook As String, ByVal lpszOldEntry As String, ByVal lpszNewEntry As String) As Long

'-------------------------------------------------
' Funzioni, Strutture e costanti utilizzate
' da RasDial
'-------------------------------------------------
Public Const UNLEN = 256 + 1
Public Const DNLEN = 15 + 1
Public Const PWLEN = 256 + 1


Public Type RASDIALEXTENSIONS
    dwSize As Long  '16
    dwfOptions As Long
    hwndParent As Long
    reserved As Long
End Type

Public Type RASDIALPARAMS
    dwSize As Long  '736
    szEntryName As String * RAS_MaxEntryName
    szPhoneNumber As String * RAS_MaxPhoneNumber
    szCallbackNumber As String * RAS_MaxCallbackNumber
    szUserName As String * UNLEN
    szPassword As String * PWLEN
    szDomain As String * DNLEN
End Type

Public Declare Function RasDial Lib "RasApi32.DLL" Alias "RasDialA" (lpRasDialExtensions As Any, ByVal lpszPhonebook As String, lprasdialparams As Any, ByVal dwNotifierType As Long, lpvNotifier As Long, lphRasConn As Long) As Long


'-------------------------------------------------
' Funzioni, Strutture e costanti utilizzate
' da RasGetEntryProperties, RasSetEntryProperties,
' RasGetCountryInfo e RasEnumDevices
'-------------------------------------------------

Public Const MAX_PATH = 260

Public Const RAS_MaxIpAddress = 15
Public Const RAS_MaxIpxAddress = 21
Public Const RAS_MaxAreaCode = 10
Public Const RAS_MaxPadType = 32
Public Const RAS_MaxX25Address = 200
Public Const RAS_MaxFacilities = 200
Public Const RAS_MaxUserData = 200

Public Const RASEO_UseCountryAndAreaCodes = &H1
Public Const RASEO_SpecificIpAddr = &H2
Public Const RASEO_SpecificNameServers = &H4
Public Const RASEO_IpHeaderCompression = &H8
Public Const RASEO_RemoteDefaultGateway = &H10
Public Const RASEO_DisableLcpExtensions = &H20
Public Const RASEO_TerminalBeforeDial = &H40
Public Const RASEO_TerminalAfterDial = &H80
Public Const RASEO_ModemLights = &H100
                                                 
Public Const RASEO_SwCompression = &H200
Public Const RASEO_RequireEncryptedPw = &H400
                                                 
Public Const RASEO_RequireMsEncryptedPw = &H800
Public Const RASEO_RequireDataEncryption = &H1000
Public Const RASEO_NetworkLogon = &H2000
Public Const RASEO_UseLogonCredentials = &H4000
Public Const RASEO_PromoteAlternates = &H8000

Public Const RASNP_NetBEUI = &H1    'NETBEUI
Public Const RASNP_Ipx = &H2        'IPX
Public Const RASNP_Ip = &H4         'TCP/IP

Public Const RASFP_Ppp = &H1        'PPP
Public Const RASFP_Slip = &H2       'SLIP
Public Const RASFP_Ras = &H4        'RAS

Public Const ERROR_BUFFER_TOO_SMALL = 603
Public Const ERROR_NOT_ENOUGH_MEMORY = 8
Public Const ERROR_INVALID_PARAMETER = 87
Public Const ERROR_INVALID_USER_BUFFER = 1784&

Public Type RASCTRYINFO
    dwSize As Long
    dwCountryID As Long
    dwNextCountryID As Long
    dwCountryCode As Long
    dwCountryNameOffset As Long
    Stringa As String * 512    'aggiunta: non  presente nella dichiarazione originale della struttura
End Type

Public Type RASIPADDR
    classA As Byte
    classB As Byte
    classC As Byte
    classD As Byte
End Type

Public Type RASENTRY
    dwSize As Long
    dwfOptions As Long
    dwCountryID As Long
    dwCountryCode As Long
    szAreaCode(RAS_MaxAreaCode) As Byte
    'Il campo seguente ha la dimensione modificata perch:
    'RasDial vuole MaxPhoneNumber = 128 +1
    'mentre RasSetEntryProperties vuole MaxPhoneNumber = 128
    szLocalPhoneNumber(RAS_MaxPhoneNumber - 1) As Byte
    dwAlternatesOffset As Long
    ipaddr As RASIPADDR
    ipaddrDns As RASIPADDR
    ipaddrDnsAlt As RASIPADDR
    ipaddrWins As RASIPADDR
    ipaddrWinsAlt As RASIPADDR
    dwFrameSize As Long
    dwfNetProtocols As Long
    dwFramingProtocol As Long
    szScript(MAX_PATH) As Byte
    szAutodialDll(MAX_PATH) As Byte
    'Il campo seguente ha una dimensione diversa da quella standard dichiarata da Microsoft
    szAutodialFunc(MAX_PATH - 3) As Byte
    szDeviceType(RAS_MaxDeviceType) As Byte
    szDeviceName(RAS_MaxDeviceName) As Byte
    szX25PadType(RAS_MaxPadType) As Byte
    szX25Address(RAS_MaxX25Address) As Byte
    szX25Facilities(RAS_MaxFacilities) As Byte
    szX25UserData(RAS_MaxUserData) As Byte
    dwChannels As Long
    dwReserved1 As Long
    dwReserved2 As Long
End Type

Public Type RASDEVINFO
    dwSize As Long
    szDeviceType(RAS_MaxDeviceType) As Byte
    szDeviceName(RAS_MaxDeviceName) As Byte
End Type

Public Declare Function RasGetEntryProperties Lib "RasApi32.DLL" Alias "RasGetEntryPropertiesA" (ByVal lpszPhonebook As String, ByVal lpszEntry As String, lpRasEntry As Any, lpdwEntryInfoSize As Long, lpbDeviceInfo As Any, lpdwDeviceInfoSize As Long) As Long
Public Declare Function RasSetEntryProperties Lib "RasApi32.DLL" Alias "RasSetEntryPropertiesA" (ByVal lpszPhonebook As String, ByVal lpszEntry As String, lpRasEntry As Any, lpdwEntryInfoSize As Long, lpbDeviceInfo As Any, lpdwDeviceInfoSize As Long) As Long
Public Declare Function RasGetCountryInfo Lib "RasApi32.DLL" Alias "RasGetCountryInfoA" (lpRasCtryInfo As Any, lpdwSize As Long) As Long
Public Declare Function RasEnumDevices Lib "RasApi32.DLL" Alias "RasEnumDevicesA" (lpRasDevInfo As Any, lpcb As Long, lpcDevices As Long) As Long
Public Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (lpString1 As Any, ByVal lpString2 As String) As Long





