Attribute VB_Name = "ModuloExe"
Option Explicit

Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type

Private Const RAS_MAXENTRYNAME = 256
Private Const RAS_MAXDEVICETYPE = 16
Private Const RAS_MAXDEVICENAME = 128
Private Const RAS_RASCONNSIZE = 412

Private Type RasConn
    dwSize As Long
    hRasConn As Long
    szEntryName(RAS_MAXENTRYNAME) As Byte
    szDeviceType(RAS_MAXDEVICETYPE) As Byte
    szDeviceName(RAS_MAXDEVICENAME) As Byte
End Type

Private Declare Function RasEnumConnections Lib "rasapi32.dll" Alias "RasEnumConnectionsA" (lpRasConn As Any, lpcb As Long, lpcConnections As Long) As Long

Public Const ERROR_SUCCESS = 0&

Public Const REG_OPTION_BACKUP_RESTORE = 4     ' open for backup or restore
Public Const REG_OPTION_VOLATILE = 1           ' Key is not preserved when system is rebooted
Public Const REG_OPTION_NON_VOLATILE = 0       ' Key is preserved when system is rebooted
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const SYNCHRONIZE = &H100000
Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Public Const KEY_EXECUTE = (KEY_READ)
Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_CURRENT_USER = &H80000001
Public Const REG_DWORD As Long = 4


Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Public Declare Function RasDial Lib "rasapi32.dll" Alias "RasDialA" (lpRasDialExtensions As Any, ByVal lpszPhonebook As String, lprasdialparams As Any, ByVal dwNotifierType As Long, lpvNotifier As Long, lphRasConn As Long) As Long

Public Function PathApp() As String
PathApp = IIf(Right$(App.Path, 1) <> "\", App.Path & "\", App.Path)
End Function
Public Function WinVer() As Long
Dim ret As Long, typeOSINFO  As OSVERSIONINFO
typeOSINFO.dwOSVersionInfoSize = 148
ret = GetVersionEx(typeOSINFO)
If ret <> 0 Then WinVer = typeOSINFO.dwPlatformId
End Function

Public Function RegAttiva() As Boolean
Dim i As Long, lpRasConn(255) As RasConn, lpcb As Long
Dim lpcConnections As Long, hRasConn As Long, ret As Long
'Set the structure's size
lpRasConn(0).dwSize = RAS_RASCONNSIZE
lpcb = RAS_MAXENTRYNAME * lpRasConn(0).dwSize
lpcConnections = 0
'Enumerate all the available connections
ret = RasEnumConnections(lpRasConn(0), lpcb, lpcConnections)
If ret = 0 Then
    RegAttiva = IIf(lpcConnections > 0, True, False)
End If
End Function
Public Sub AvviaConnremota(ByVal Cremota As String)
Dim ret As Long, IsAttiva As Boolean, IsAutoDial As Boolean
IsAttiva = RegAttiva
'IsAutoDial = IsAttivoAutoDial(Cremota)

If Not IsAttiva Then
    If WinVer = 1 Then
        ret = Shell("rundll32.exe rnaui.dll,RnaDial " & Cremota, vbNormalFocus)
    Else
        ret = Shell("Rasphone -d """ & Cremota & """", vbNormalFocus)
    End If
    'If Not IsAutoDial Then
    AppActivate ret
    'SendKeys ("{ENTER}")
    'End If
End If
End Sub

'//////////////////////////////////////////////////////////////////////////////////////////

Public Function IsAttivoAutoDial(ByVal NomeCRemota As String) As Boolean
Dim handle As Long, lpData As Long, ret As Long, TmpChiave As String
If WinVer = 1 Then
    TmpChiave = ".DEFAULT\RemoteAccess\Profile\" & NomeCRemota
    ret = RegOpenKey(HKEY_USERS, TmpChiave, handle)
Else
    TmpChiave = "RemoteAccess\Profile\" & NomeCRemota
    ret = RegOpenKey(HKEY_CURRENT_USER, TmpChiave, handle)
End If

If ret <> ERROR_SUCCESS Then Exit Function

ret = RegQueryValueEx(handle, "AutoConnect", vbNull, REG_DWORD, lpData, Len(lpData))

If ret = ERROR_SUCCESS Then IsAttivoAutoDial = IIf(lpData = 0, False, True)
RegCloseKey (handle)
End Function
